Unexpected behavior when switching to a status with no %-done value

2024-07-15 14:34 - Liane Hampe

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version:

Resolution: Affected version: 51.3
Description

Suppose having this setting for issue status:

Calculate the issue done ratio wil|1

Use the issue status

Non-working days
Tasks export limit

Maximum number of items displayed on

the gantt chart

Maximum number of months displayed on

the gantt chart

Parent tasks attributes

Start date / Due date

[ Monday []Tuesday []Wednesday []Thu
500

500

24

Calculated from subtasks

Calculated from subtasks

Calculated from subtasks

Priority
%% Don
Task statuses
Status % Done
New
Assigned
In progress 20
Resolved 50
Feedback 60
Closed 100
Rejected

Task closed
Description for New issue status
Description for Assigned issue status
Description for Resolved issue status
L 4
L 4

A user having the an issue to status “In progress” will the %-done value as expected:
Bug #16 Pr 1 15| Next »
Subtask 2

Added by Redmine Admin 38 minutes ago. Updated
less than a minute ago.

Status: In progress

Priority: Normal
Assignee: -
Category: -

Start date: 07/15/2024
Due date:
% Done: 20%

Estimated time:

Switching, however, to a status having not %-done value assigned at all behaves unexpected:

Bug #16 Pr 1 of 15| Next=»
Subtask 2

Added by Redmine Admin 40 minutes ago. Updated
less than a minute ago.

Status: Assigned

Priority: Normal
Assignee: -
Category: -

Start date: 07/15/2024
Due date:
% Done: 20%

Estimated time:

Subtasks Add
Related issues Add
History

#1 - 2024-07-15 15:59 - Go MAEDA

In this case, the “Assigned” status has no “% done” value set. So, when the issue status is changed to “Assigned,” the “% done” remains at 20%. |
think this is the expected behavior.

Could you let me know what behavior you expect?

#2 - 2024-07-21 13:23 - Liane Hampe

Thank you Go MAEDA for paying attention to this issue.

This is what | expect when changing the status forth and back according to a workflow which allows this flexibility:

Assigning no "%-done" value to a status | do understand to be equal to zero and not to preserve the "%-done" value accompanied with the previous
status.

Reason:
On a ticket the user will see 0% if the issue is new assuming the settings above. The Ul does not differentiate in having a "%-done" value predefined

in admin area or not in this case. The difference between assigning 0% and assigning nothing will only be visible when a user changes back from a
status with "%-done" greater 0 to a status with unset "%-done" value since nothing will change. So it feels unexpected to me.
https://www.redmine.org/users/332

Do you think there is a real use case where this behavior would make sense? | am always open for discussion.

#3 - 2024-07-22 11:27 - Holger Just

| actually don't think that assuming "0% done" rather than not setting a value for statuses with no value set is a better solution. | think that his would
lead to more data inconsistencies along the way. | believe that the current default is sensible and in line with a lot of other settings in Redmine. Also,
explicitly setting 0% for all statuses can be done by the admin. Preserving the current value would then not be possible.

With that being said, setting the "% done" value based on the status and then not defining a value for all status is likely an oversight by the admin (on
the border of undefined behavior). Thus, it may be a good idea instead to show an appropriate warning message in the status config list (and possibly
also below the "calculate issue done ratio with" setting) if there are any statuses which do not have a %done value defined if the setting is set to use
the issue status. Then, I'd be in favor of keeping the current behavior of not setting a new %done value of none is defined for the status.

#4 - 2024-08-01 10:09 - Go MAEDA
| share the same opinion as Holger Just. When subtasks exist, if the "% done" value is not set for a status, the parent issue's "% done" is calculated
based on the "% done" values and estimated hours of the subtasks. | think that some Redmine users effectively utilize this behavior.

If we change the behavior to set the value to 0% when the "% done" for the status is blank, it will be a breaking change for those who rely on this
current behavior.
